// BG.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "bcCommon.h"
#include "memory.h"


#define WM_TASKICON (WM_USER + 27)
#define ICON_ERROR 15
#define ICON_PAUSE 16
#define MAX_JOB	100


HICON icons[17];
HMENU menu;
UINT lst[MAX_JOB];
UINT lst_size=0;
HINSTANCE hinst;
char skin[500];
char sound[500];

void load_config()
{
	HKEY hKey;
	DWORD type;
	DWORD datasize;

	if(RegOpenKey(HKEY_CURRENT_USER,"Software\\BGCD", &hKey)==ERROR_SUCCESS)
	{	
		datasize = 500;
		RegQueryValueEx(hKey, "skin", 0, &type,(BYTE *) &skin, &datasize);
		datasize = 500;
		RegQueryValueEx(hKey, "sound", 0, &type,(BYTE *) &sound, &datasize);
	};
};


void list_remove(UINT lst[MAX_JOB], UINT num, UINT *size)
{
	(*size)--;
	lst[num] = lst[*size];
}

void list_add(UINT lst[MAX_JOB], UINT num, UINT *size)
{
	lst[*size] = num;
	(*size)++;
}

void SendCommand(DWORD ThreadId,DWORD Command)
{
  DWORD send[3]={OPERATION_INFO,Command,ThreadId};
  DWORD Transfered;
  HANDLE hPipe=CreateFile(PIPE_NAME,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
  if(hPipe!=INVALID_HANDLE_VALUE)
  {
    WriteFile(hPipe,send,sizeof(send),&Transfered,NULL);
    CloseHandle(hPipe);
  }
}

bool GetInfo(DWORD ThreadId,InfoRec *receive)
{
  bool res=false;
  DWORD dwBytesRead,dwBytesWritten;
  DWORD send[3]={OPERATION_INFO,INFOFLAG_BYHANDLE};
  send[2]=ThreadId;
  receive->info.type=INFOTYPE_INVALID;
  HANDLE hPipe=CreateFile(PIPE_NAME,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
  if(hPipe!=INVALID_HANDLE_VALUE)
  {
    WriteFile(hPipe,send,sizeof(send),&dwBytesWritten,NULL);
    ReadFile(hPipe,receive,sizeof(InfoRec),&dwBytesRead,NULL);
    CloseHandle(hPipe);
  }
  else if(GetLastError()==ERROR_PIPE_BUSY) res=true;
  return res;
}

static bool GetJobList(DWORD *size,SmallInfoRec **receive)
{
  *size=0; *receive=NULL;
  bool res=false;
  {
    DWORD send[2]={OPERATION_INFO,INFOFLAG_ALL};
    DWORD dwBytesRead,dwBytesWritten;
    HANDLE hPipe=CreateFile(PIPE_NAME,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
    if(hPipe!=INVALID_HANDLE_VALUE)
    {
      if(WriteFile(hPipe,send,sizeof(send),&dwBytesWritten,NULL))
        if(ReadFile(hPipe,size,sizeof(*size),&dwBytesRead,NULL))
        {
          res=true;
          if(*size)
          {
            *receive=(SmallInfoRec *)malloc(sizeof(SmallInfoRec)*(*size));
            if((!(*receive))||(!ReadFile(hPipe,*receive,sizeof(SmallInfoRec)*(*size),&dwBytesRead,NULL)))
            {
              *size=0;
              free(*receive);
              *receive=NULL;
              res=false;
            }
          }
        }
      CloseHandle(hPipe);
    }
  }
  return res;
}

int MsgLoop()
{
	MSG msg;
	while(GetMessage(&msg,0,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	};
	return(msg.wParam);
}

BOOL systray_add(HWND hwnd, UINT uID, HICON hIcon, LPSTR lpszTip)
{
  NOTIFYICONDATA tnid;
  tnid.cbSize = sizeof(NOTIFYICONDATA);
  tnid.hWnd = hwnd;
  tnid.uID = uID;
  tnid.uFlags = NIF_ICON | NIF_TIP | NIF_MESSAGE;
  tnid.uCallbackMessage = WM_TASKICON;
  tnid.hIcon = hIcon;
  lstrcpyn(tnid.szTip,lpszTip,sizeof(tnid.szTip)-1);
  return (Shell_NotifyIcon(NIM_ADD, &tnid));
}

BOOL systray_update(HWND hwnd, UINT uID, HICON hIcon, LPSTR lpszTip)
{
  NOTIFYICONDATA tnid;
  tnid.cbSize = sizeof(NOTIFYICONDATA);
  tnid.hWnd = hwnd;
  tnid.uID = uID;
  tnid.uFlags = NIF_ICON | NIF_TIP | NIF_MESSAGE;
  tnid.uCallbackMessage = WM_TASKICON;
  tnid.hIcon = hIcon;
  lstrcpyn(tnid.szTip,lpszTip,sizeof(tnid.szTip)-1);
  BOOL res = Shell_NotifyIcon(NIM_MODIFY, &tnid);
  if(!res) res = Shell_NotifyIcon(NIM_ADD, &tnid);
  return (res);
}


BOOL systray_del(HWND hwnd, UINT uID) {
  NOTIFYICONDATA tnid;
  tnid.cbSize = sizeof(NOTIFYICONDATA);
  tnid.hWnd = hwnd;
  tnid.uID = uID;
  return(Shell_NotifyIcon(NIM_DELETE, &tnid));
}

BOOL load_resources(HINSTANCE hInstance)
{
	icons[0] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON0));
	icons[1] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
	icons[2] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON2));
	icons[3] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON3));
	icons[4] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON4));
	icons[5] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON5));
	icons[6] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON6));
	icons[7] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON7));
	icons[8] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON8));
	icons[9] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON9));
	icons[10] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON10));
	icons[11] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON11));
	icons[12] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON12));
	icons[13] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON13));
	icons[14] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON14));
	icons[ICON_ERROR] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICONERROR));
	icons[ICON_PAUSE] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICONPAUSE));
	menu = LoadMenu(hInstance,MAKEINTRESOURCE(IDR_MENU1));
//	icon.fIcon = TRUE;
//	icon.hbmColor = LoadBitmap(hInstance,MAKEINTRESOURCE(IDB_BITMAP1));
//	icon.hbmMask = icon.hbmColor;
//	icons[ICON_PAUSE] = CreateIconIndirect(&icon);

	return(1);
}
BOOL CALLBACK  AboutDialogProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam) {return 0;};

BOOL CALLBACK  DialogProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	int result;
	BOOL found = 0;
	POINT cur;
	SmallInfoRec *list;
	DWORD size;
	char file[500];

	switch(uMsg)
	{
	case WM_TASKICON:
		switch((UINT)lParam)
		{
		case WM_LBUTTONDOWN:SendCommand((UINT)wParam,INFOFLAG_PAUSE);break;
		case WM_RBUTTONDOWN:
			GetCursorPos(&cur);
			result = TrackPopupMenu(GetSubMenu(menu,0),TPM_RIGHTALIGN|TPM_RETURNCMD|TPM_NONOTIFY,cur.x,cur.y,0,hwndDlg,0);
			switch(result)
			{
			case ID_MENUEXIT: PostQuitMessage(0); break;
			case ID_MENUPAUSE: SendCommand((UINT)wParam,INFOFLAG_PAUSE); break;
			case ID_MENUSTOP: SendCommand((UINT)wParam,INFOFLAG_STOP);break;
			};
			break;
		};
		break;
	case WM_TIMER:
		char hint[500];
		UINT i, j, icon;
		InfoRec info;

		if(GetJobList(&size, &list))
		{
			for(i=0;i<size;i++) //     ,    
			{
				int found = 0;
				for(j=0;j<lst_size;j++) 
					if(list[i].ThreadId == lst[j]) 
					{
						WideCharToMultiByte(CP_ACP,0,list[i].Src,-1,file,sizeofa(file),NULL,NULL);
						char *operation = "<<>>";
						icon = list[i].pause?ICON_PAUSE:14*list[i].percent/100;
						GetInfo(list[i].ThreadId,&info);
						if(list[i].type && INFOTYPE_COPY) operation = ""; else 
						if(list[i].type && INFOTYPE_MOVE) operation = ""; else 
						if(list[i].type && INFOTYPE_WIPE) operation = ""; else 
						if(list[i].type && INFOTYPE_DELETE) operation = ""; else 
						if(list[i].type && INFOTYPE_DELETE) operation = " ";
						sprintf((char *)&hint,"%s %s\n %i%%",operation,file,list[i].percent);
						systray_update(hwndDlg,list[i].ThreadId,icons[icon],hint);
						found = 1;
					};
				if(!found) 
				{
					list_add(lst,list[i].ThreadId,&lst_size); //  
					sprintf((char *)&hint," %i%%",list[i].percent);
					systray_add(hwndDlg,list[i].ThreadId,icons[14*list[i].percent/100],hint);
				};
			}; 
			for(j=0;j<lst_size;j++)		 //   ,   
			{
				int found = 0;
				for(i=0;i<size;i++) 
					if(list[i].ThreadId == lst[j]) { found = 1; break; }
				if(!found) 
				{
					systray_del(hwndDlg,lst[j]);
					list_remove(lst,j,&lst_size); //
				};
			}; 
		};
		break;

	};
	return(1);
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.

	if(!FindWindow(0,"(BGCOPY ) "))
	{
		HWND wnd;
		hinst = hInstance;
		wnd = CreateDialog(hInstance,MAKEINTRESOURCE(IDD_DIALOGABOUT),0,&DialogProc);
		load_resources(hInstance);
		SetTimer(wnd,0,100,0);
		SendMessage(wnd,WM_TIMER,0,0);
		MsgLoop();
		for(UINT i=0;i<lst_size;i++) systray_del(wnd,lst[i]);
	};
	return 0;
}



